@echo off

REM Lowifyer v1.4 By stuartt#2419 // mcoded.repl.co

REM If you don't know what you're doing (especially for the bitrate), it's best to leave these alone.
set FPS=5
set Bitrate=8k
set Scale=32:32

title Lowifyer v1.4
echo.
echo Lowifyer - Low Quality Video Tool v1.4
echo (C) 2021 mcoded.repl.co
echo.
echo Remove any '^&' characters from URLs you are using in here.
echo If you are using a Reddit link, remove "?utm_source=share&utm_medium=web2x&context=3" from the URL.
echo.
set /p InputFile=Input File Location/Link: 
echo.

REM Youtube Link Check
Echo.%InputFile% | findstr /C:"youtube.com">nul && (
	echo FOUND YouTube Link!
	youtube-dl -f 18 -o yt-dl.mp4 %InputFile%
	set InputFile=yt-dl.mp4
	echo.
)

REM Twitter link check
Echo.%InputFile% | findstr /C:"twitter.com">nul && (
	echo FOUND Twitter Link!
	youtube-dl -o yt-dl.mp4 %InputFile%
	set InputFile=yt-dl.mp4
	echo.
)

REM Reddit link check
Echo.%InputFile% | findstr /C:"reddit.com">nul && (
	echo FOUND Reddit Link!
	youtube-dl -o yt-dl.mp4 %InputFile%
	set InputFile=yt-dl.mp4
	echo.
)

echo Compression may take some time to finish depending on the video duration and your GPU.
echo.
echo Compression Part 1/3 (Video Framerate) in progress...

ffmpeg -hide_banner -loglevel panic -i %InputFile% -filter:v fps=fps=%FPS% tmp.webm

echo Compression Part 1/3 (Video Framerate) finished.
echo.
echo Compression Part 2/3 (Audio Bitrate) in progress...

ffmpeg -hide_banner -loglevel panic -i tmp.webm -b:a %Bitrate% tmp2.webm

echo Compression Part 2/3 (Audio Bitrate) finished.
echo.
echo Compression Part 3/3 (Video Scale) in progress...

ffmpeg -hide_banner -loglevel panic -i tmp2.webm -vf scale=%Scale% lowifyer.mp4

echo Compression Part 3/3 (Video Scale) finished.
echo.
echo Deleting temp files
if exist yt-dl.mp4 del yt-dl.mp4
del tmp.webm
del tmp2.webm
echo Finished! Opening file...
lowifyer.mp4
echo.
echo Press any key to exit...
pause >nul
title 